## feature-check 0.1.1

=== Makefile ===
#!/usr/bin/make -f
#
# Copyright (c) 2018  Peter Pentchev
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

PROG=		feature-check

MAN1=		feature-check.1
MAN1GZ=		${MAN1}.gz

INSTALL?=	install
MKDIR?=		mkdir -p
RM?=		rm -f
FALSE?=		false

LOCALBASE?=	/usr/local
PREFIX?=	${LOCALBASE}
BINDIR?=	${PREFIX}/bin
MANDIR?=	${PREFIX}/man/man
DOCSDIR?=	${PREFIX}/share/doc/feature-check
EXAMPLESDIR?=	${DOCSDIR}/examples

BINOWN?=	root
BINGRP?=	wheel
BINMODE?=	555

SHAREOWN?=	root
SHAREGRP?=	wheel
SHAREMODE?=	644

COPY?=		-c
STRIP?=		-s

INSTALL_PROGRAM?=	${INSTALL} ${COPY} ${STRIP} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
INSTALL_SCRIPT?=	${INSTALL} ${COPY} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
INSTALL_DATA?=		${INSTALL} ${COPY} -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE}

all:		${PROG} ${MAN1GZ}

clean:
		${RM} ${PROG} ${MAN1GZ}

install:	all
		${MKDIR} ${DESTDIR}${BINDIR}
		${INSTALL_SCRIPT} ${PROG} ${DESTDIR}${BINDIR}
		${MKDIR} ${DESTDIR}${MANDIR}1
		${INSTALL_DATA} ${MAN1GZ} ${DESTDIR}${MANDIR}1
		${MKDIR} ${DESTDIR}${DOCSDIR}
		${INSTALL_DATA} README.md ${DESTDIR}${DOCSDIR}

test-single:	${TEST_PROG}
		echo "Testing ${TEST_PROG}"
		prove t
		echo "Testing ${TEST_PROG} complete"

test-real:	${PROG}
		${MAKE} test-single TEST_PROG="./${PROG}"

test:		test-real

test-all:
		(set -e; for f in \
			perl5/feature-check.pl \
			python/2/feature-check.sh python/3/feature-check.sh \
			; do \
			if [ "$${f#python}" != "$$f" ]; then \
				flake8 "$$(dirname "./$$f")/../feature-check.py"; \
			fi; \
			${MAKE} test-single TEST_PROG="./$$f"; \
		done)
		@echo 'Testing all the feature-check implementations complete'

${PROG}:	perl5/feature-check.pl
		${INSTALL} -m 755 perl5/feature-check.pl ${PROG}

${MAN1GZ}:	${MAN1}
		gzip -c9 ${MAN1} > ${MAN1GZ}.tmp || (${RM} ${MAN1GZ}.tmp; ${FALSE})
		mv ${MAN1GZ}.tmp ${MAN1GZ} || (${RM} ${MAN1GZ} ${MAN1GZ}.tmp; ${FALSE})

.PHONY:		all clean test test-real test-single test-all

=== debian/changelog ===
feature-check (0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Use my Debian e-mail address in the Maintainer field.

 -- Peter Pentchev <roam@debian.org>  Tue, 15 May 2018 10:57:09 +0300

feature-check (0.1.0-1) unstable; urgency=low

  * Initial release.  Closes: #896892

 -- Peter Pentchev <roam@ringlet.net>  Fri, 04 May 2018 16:42:30 +0300

=== debian/control ===
Source: feature-check
Section: utils
Priority: optional
Maintainer: Peter Pentchev <roam@debian.org>
Build-Depends:
 debhelper (>> 11~),
 libjson-xs-perl,
 libtest-command-perl,
 perl
Standards-Version: 4.1.4
Vcs-Git: https://gitlab.com/ppentchev/feature-check.git -b debian
Vcs-Browser: https://gitlab.com/ppentchev/feature-check/tree/debian
Homepage: https://devel.ringlet.net/misc/feature-check/
Rules-Requires-Root: no

Package: feature-check
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${perl:Depends},
 libjson-xs-perl
Description: tool to query a program for supported features
 The feature-check tool obtains the list of supported features from
 a program via various methods (e.g. running it with the --features
 command-line option) and allows other programs to check for
 the presence and, possibly, versions of specific features.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh "$@"

override_dh_auto_install:
	dh_auto_install -- \
		PREFIX=/usr \
		MANDIR=/usr/share/man/man \
		INSTALL_SCRIPT='install -m 755' \
		INSTALL_DATA='install -m 644'

=== debian/tests/control ===
Test-Command: env TEST_PROG='/usr/bin/feature-check' prove t
Depends: @, libtest-command-perl, perl

## feature-check 0.2.2

=== Makefile ===
--- 
+++ 
@@ -85,7 +85,7 @@
 			python/2/feature-check.sh python/3/feature-check.sh \
 			; do \
 			if [ "$${f#python}" != "$$f" ]; then \
-				flake8 "$$(dirname "./$$f")/../feature-check.py"; \
+				flake8 "$$(dirname "./$$f")/../feature_check"; \
 			fi; \
 			${MAKE} test-single TEST_PROG="./$$f"; \
 		done)

=== debian/changelog ===
feature-check (0.2.2-5) unstable; urgency=medium

  * Declare compliance with Policy 4.5.0 with no changes.
  * Add the year 2020 to my debian/* copyright notice.
  * Drop the adequate autopkgtest.
  * Drop the Name and Contact upstream metadata fields.
  * Test against supported, not installed, Python versions.
  * Configure pybuild and pytest through the environment.
  * Use debian/clean to remove subdirectories.
  * Use a build dependency on dh-sequence-python3.
  * Update the debhelper compat level to 13:
    - drop the conditional around the dh_auto_test target
    - `dh_missing --fail-missing` is now the default
    - use execute_after targets

 -- Peter Pentchev <roam@debian.org>  Sun, 10 May 2020 01:40:56 +0300

feature-check (0.2.2-4) unstable; urgency=medium

  * Mark the adequate autopkgtest as superficial.
  * Declare compliance with Policy 4.4.0 with no changes.
  * Fix the tap-python test (both build-time and autopkgtest) to
    actually test with the various Python interpreters, not just pypy.
  * Also skip the tests in the "nocheck" build profile.
  * Annotate test-related build dependencies with <!nocheck>.
  * Run the Salsa CI jobs.
  * Drop the PyPy package.
  * Drop the Python 2 package, too.  Closes: #936510
  * Point the Vcs-* headers to the Salsa mirror.

 -- Peter Pentchev <roam@debian.org>  Tue, 24 Sep 2019 11:32:16 +0300

feature-check (0.2.2-3) unstable; urgency=medium

  * Switch to a DEP-14 debian/master branch.
  * Add a simple git-buildpackage config file.
  * Use the test-name autopkgtest feature.

 -- Peter Pentchev <roam@debian.org>  Tue, 26 Feb 2019 17:08:55 +0200

feature-check (0.2.2-2) unstable; urgency=medium

  * Add a patch to not install the Python command-line executable
    even internally during the build.
  * Use the PYBUILD_* variables in the rules file.
  * Add a PyPy package.
  * Use a single tool for TAP testing the Python modules.
  * Check for "nocheck" in DEB_BUILD_OPTIONS before running any tests.

 -- Peter Pentchev <roam@debian.org>  Mon, 14 Jan 2019 17:43:43 +0200

feature-check (0.2.2-1) unstable; urgency=medium

  * New upstream release, update the upstream copyright years.
  * Declare compliance with Debian Policy 4.3.0 with no changes.
  * Bump the debhelper compatibility level to 12 with no changes.
  * Add the year 2019 to my debian/* copyright notice.
  * Run the TAP tests with the Python 2 and Python 3 modules,
    not just the Perl command-line tool.
  * Add a trivial git-buildpackage config file.

 -- Peter Pentchev <roam@debian.org>  Wed, 09 Jan 2019 22:31:26 +0200

feature-check (0.2.1-1) unstable; urgency=medium

  * New upstream release: drop the dependency on python-typing.
  * Drop shlibs:Depends from all the binary packages: they are all either
    in Perl or in Python.
  * Make full use of the python:* and python3:* variables, even if
    some of them will not be defined for this package.

 -- Peter Pentchev <roam@debian.org>  Tue, 27 Nov 2018 11:23:49 +0200

feature-check (0.2.0-1) unstable; urgency=medium

  * Bring up to compliance with Debian Policy 4.2.1: install the upstream
    release notes (CHANGES.md) as NEWS and not changelog.
  * Use the B-D: debhelper-compat (= 11) mechanism.
  * Add a trivial autopkgtest running adequate on the installed package.
  * New upstream release:
    - build the Python libraries
    - add two autopkgtest cases for the Python libraries
  * Minimize the upstream signing key, only keep the roam@ringlet.net UID.

 -- Peter Pentchev <roam@debian.org>  Fri, 23 Nov 2018 02:01:44 +0200

=== debian/control ===
Source: feature-check
Section: utils
Priority: optional
Maintainer: Peter Pentchev <roam@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 libjson-xs-perl <!nocheck>,
 libtest-command-perl <!nocheck>,
 perl <!nocheck>,
 python3-all,
 python3-ddt <!nocheck>,
 python3-pytest <!nocheck>,
 python3-six <!nocheck>,
 python3-setuptools
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/roam/feature-check.git
Vcs-Browser: https://salsa.debian.org/roam/feature-check/
Homepage: https://devel.ringlet.net/misc/feature-check/
Rules-Requires-Root: no

Package: feature-check
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libjson-xs-perl
Description: tool to query a program for supported features
 The feature-check tool obtains the list of supported features from
 a program via various methods (e.g. running it with the --features
 command-line option) and allows other programs to check for
 the presence and, possibly, versions of specific features.
 .
 This package contains the command-line tool for use by any program.

Package: python3-feature-check
Section: python
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${python3:Depends}
Recommends:
 ${python3:Recommends}
Suggests:
 ${python3:Suggests}
Provides:
 ${python3:Provides}
Description: query a program for supported features - Python 3.x library
 The feature-check tool obtains the list of supported features from
 a program via various methods (e.g. running it with the --features
 command-line option) and allows other programs to check for
 the presence and, possibly, versions of specific features.
 .
 This package contains the Python 3.x library.

=== debian/rules ===
#!/usr/bin/make -f

D=	${CURDIR}/debian
DTMP=	$D/tmp
PY=	${CURDIR}/python

export PYBUILD_NAME=		feature_check
export PYBUILD_DIR=		${PY}
export PYBUILD_TEST_PYTEST=	1
export PYTEST_ADDOPTS=		${PY}/unit_tests

%:
	dh "$@"

execute_after_dh_auto_build:
	dh_auto_build --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install -- \
		PREFIX=/usr \
		MANDIR=/usr/share/man/man \
		INSTALL_SCRIPT='install -m 755' \
		INSTALL_DATA='install -m 644'
	dh_auto_install --buildsystem pybuild

execute_after_dh_auto_test:
	env PYTHONPATH='${PY}' debian/tests/tap-python.sh
	dh_auto_test --buildsystem pybuild

override_dh_installchangelogs:
	dh_installchangelogs -X CHANGES.md
	install -m 644 -- CHANGES.md '$D/feature-check/usr/share/doc/feature-check/NEWS'

execute_after_dh_auto_clean:
	dh_auto_clean --buildsystem pybuild

=== debian/tests/control ===
Tests: tap-python.sh
Depends: @, libtest-command-perl, perl

Test-Command: env TEST_PROG='/usr/bin/feature-check' prove t
Depends: @, libtest-command-perl, perl
Features: test-name=tap-perl

Test-Command: pytest-3 python/unit_tests
Depends: @, python3-ddt, python3-pytest
Features: test-name=upstream-pytest-python3

## feature-check 1.0.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 #
-# Copyright (c) 2018  Peter Pentchev
+# Copyright (c) 2018, 2019, 2021  Peter Pentchev
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -25,6 +25,9 @@
 # SUCH DAMAGE.
 
 PROG=		feature-check
+
+FCHKDATA_PROG?=	${CURDIR}/fcheck-testdata/target/release/fcheck-testdata
+FCHKDATA_DIR?=	${CURDIR}/fcheck-testdata/data
 
 MAN1=		feature-check.1
 MAN1GZ=		${MAN1}.gz
@@ -56,6 +59,8 @@
 INSTALL_SCRIPT?=	${INSTALL} ${COPY} -o ${BINOWN} -g ${BINGRP} -m ${BINMODE}
 INSTALL_DATA?=		${INSTALL} ${COPY} -o ${SHAREOWN} -g ${SHAREGRP} -m ${SHAREMODE}
 
+REGEN_PYTHON?=	python3
+
 all:		${PROG} ${MAN1GZ}
 
 clean:
@@ -82,14 +87,24 @@
 test-all:
 		(set -e; for f in \
 			perl5/feature-check.pl \
-			python/2/feature-check.sh python/3/feature-check.sh \
+			python/3/feature-check.sh \
+			rust/target/debug/feature-check \
+			rust/target/release/feature-check \
 			; do \
-			if [ "$${f#python}" != "$$f" ]; then \
-				flake8 "$$(dirname "./$$f")/../feature_check"; \
+			if [ -f "$$f" ]; then \
+				${MAKE} test-single TEST_PROG="./$$f"; \
+			else \
+				echo "Skipping nonexistent $$f" 1>&2; \
 			fi; \
-			${MAKE} test-single TEST_PROG="./$$f"; \
 		done)
 		@echo 'Testing all the feature-check implementations complete'
+
+test-regen:
+		${FCHKDATA_PROG} -o python/unit_tests/data.py -f ${FCHKDATA_DIR}/simple.json -v python/unit_tests/data.py.hbs
+		(set -e; cd python; ${REGEN_PYTHON} -m tox -e black_reformat)
+		${FCHKDATA_PROG} -o t/04-simple.t -f ${FCHKDATA_DIR}/simple.json -v t/04-simple.t.hbs
+		${FCHKDATA_PROG} -o t/bin/fcheck -f ${FCHKDATA_DIR}/simple.json -v t/bin/fcheck.hbs
+		chmod 755 t/bin/fcheck
 
 ${PROG}:	perl5/feature-check.pl
 		${INSTALL} -m 755 perl5/feature-check.pl ${PROG}

=== debian/changelog ===
feature-check (1.0.1-2) unstable; urgency=medium

  * Make the debian/clean file really clean up the Python egg-info
    directory after it was pushed down to python/src/ in confget-2.3.4.
    Closes: #1044232
  * Declare compliance with Policy 4.6.2 with no changes.
  * Add the year 2023 to my debian/* copyright notice.
  * Override a Lintian check: tappy.py loops over Python versions.
  * Use the pyproject plugin for pybuild.
  * Minor fixes to the `tappy.py` autopkgtest tool:
    - reformat with 100 characters per line
    - run through Ruff's isort implementation
    - minor fixes suggested by Ruff
    - add some infrastructure for running Python checkers on tappy.py
    - drop a type: ignore annotation, not needed for recent versions of mypy
    - drop support for Python versions before 3.9

 -- Peter Pentchev <roam@debian.org>  Sun, 27 Aug 2023 02:47:43 +0300

feature-check (1.0.1-1) unstable; urgency=medium

  * Upload to unstable.
  * Declare compliance with Debian Policy 4.6.0 with no changes.
  * New upstream release:
    - refresh the python-no-executable patch

 -- Peter Pentchev <roam@debian.org>  Fri, 17 Dec 2021 15:45:56 +0200

feature-check (1.0.0-1) experimental; urgency=medium

  * Update the git-buildpackage config for the experimental branch.
  * Declare compliance with Policy 4.5.1 with no changes.
  * Add the year 2021 to my debian/* copyright notice.
  * New upstream release:
    - update the upstream copyright years
    - adapt the python-no-executable patch (setup.py -> setup.cfg)
    - update the Python source directory in the rules test target
    - drop the cmp-num and cmp-rest patches, they were taken from upstream

 -- Peter Pentchev <roam@debian.org>  Sat, 26 Jun 2021 18:14:57 +0300

feature-check (0.2.2-7) unstable; urgency=medium

  * Add the cmp-num and cmp-rest upstream patches to fix some version
    string comparisons. Closes: #990276

 -- Peter Pentchev <roam@debian.org>  Thu, 24 Jun 2021 15:33:07 +0300

feature-check (0.2.2-6) unstable; urgency=medium

  [ Michael Hudson-Doyle ]
  * debian/tests/control: have tap-python.sh depend on python3-all so all
    supported Python 3.x versions are actually installed. Closes: 972530

  [ Peter Pentchev ]
  * Drop dh-python, dh-sequence-python3 is enough.
  * Rewrite the tap-python test in Python as tappy.

 -- Peter Pentchev <roam@debian.org>  Mon, 26 Oct 2020 11:14:52 +0200

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,17 @@
 Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-python,
  dh-sequence-python3,
  libjson-xs-perl <!nocheck>,
  libtest-command-perl <!nocheck>,
  perl <!nocheck>,
+ pybuild-plugin-pyproject,
  python3-all,
  python3-ddt <!nocheck>,
  python3-pytest <!nocheck>,
  python3-six <!nocheck>,
  python3-setuptools
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/roam/feature-check.git
 Vcs-Browser: https://salsa.debian.org/roam/feature-check/
 Homepage: https://devel.ringlet.net/misc/feature-check/

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	dh_auto_install --buildsystem pybuild
 
 execute_after_dh_auto_test:
-	env PYTHONPATH='${PY}' debian/tests/tap-python.sh
+	env PYTHONPATH='${PY}/src' debian/tests/tappy.py
 	dh_auto_test --buildsystem pybuild
 
 override_dh_installchangelogs:

=== debian/tests/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
-Tests: tap-python.sh
-Depends: @, libtest-command-perl, perl
+Tests: tappy.py
+Depends: @, libtest-command-perl, perl, python3-all
 
 Test-Command: env TEST_PROG='/usr/bin/feature-check' prove t
 Depends: @, libtest-command-perl, perl

## feature-check 2.1.0

=== debian/changelog ===
feature-check (2.1.0-2build1) oracular; urgency=medium

  * No-change rebuild for arch consistency

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 24 May 2024 20:39:07 +0000

feature-check (2.1.0-2) unstable; urgency=medium

  * Fix the no-arch-any FTBFS: split the rules file targets into
    -arch and -indep ones.

 -- Peter Pentchev <roam@debian.org>  Sun, 11 Feb 2024 12:45:56 +0200

feature-check (2.1.0-1) unstable; urgency=medium

  * Minor improvements to the internal Tox tests for the autopkgtest helper:
    - really skip manual tests in the second stage
    - improve the stages definition
    - use Ruff 0.2.1 in preview mode:
      - let it know about the format of our SPDX copyright notices
      - override another subprocess-related check
      - push some configuration settings into the ruff.lint.* tree
    - also let Ruff check and fix docstrings and trailing commas
    - use Ruff instead of Black for source code formatting
  * Declare dpkg-build-api v1, drop the implied Rules-Requires-Root.
  * Bump the debhelper compat level to 14 with no changes.
  * Point the watch file to the new download page.
  * New upstream release:
    - update the Python-related dependencies and rules:
      - switch from setuptools to hatchling
      - add pyparsing as a runtime dependency
      - drop the use of ddt for the unit test suite
      - reflect upstream's unit tests move to python/tests/unit/
      - temporarily disable the pytest run during the build
    - reflect the upstream changelog move to docs/changes.md
    - follow the upstream switch to yearless copyright notices
  * Build and install the Rust implementation of feature-check
    instead of the Perl 5 one; add the test-invalid-options patch.
  * Align some variable assignments in the rules file.

 -- Peter Pentchev <roam@debian.org>  Sun, 11 Feb 2024 01:41:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,32 +1,41 @@
 Source: feature-check
 Section: utils
 Priority: optional
-Maintainer: Peter Pentchev <roam@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Peter Pentchev <roam@debian.org>
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>> 13.11.5~),
+ cargo,
  dh-sequence-python3,
+ dpkg-build-api (= 1),
  libjson-xs-perl <!nocheck>,
+ librust-anyhow-dev,
+ librust-clap-dev,
+ librust-clap-derive-dev,
+ librust-nom-dev,
+ librust-serde-dev,
+ librust-serde-derive-dev,
+ librust-serde-json-dev,
+ librust-thiserror-dev,
  libtest-command-perl <!nocheck>,
  perl <!nocheck>,
  pybuild-plugin-pyproject,
  python3-all,
- python3-ddt <!nocheck>,
+ python3-hatchling,
+ python3-hatch-requirements-txt,
+ python3-pyparsing,
  python3-pytest <!nocheck>,
- python3-six <!nocheck>,
- python3-setuptools
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/roam/feature-check.git
 Vcs-Browser: https://salsa.debian.org/roam/feature-check/
 Homepage: https://devel.ringlet.net/misc/feature-check/
-Rules-Requires-Root: no
 
 Package: feature-check
-Architecture: all
+Architecture: any
 Multi-Arch: foreign
 Depends:
  ${misc:Depends},
- ${perl:Depends},
- libjson-xs-perl
+ ${shlibs:Depends},
 Description: tool to query a program for supported features
  The feature-check tool obtains the list of supported features from
  a program via various methods (e.g. running it with the --features
@@ -41,7 +50,8 @@
 Multi-Arch: foreign
 Depends:
  ${misc:Depends},
- ${python3:Depends}
+ ${python3:Depends},
+ python3-pyparsing,
 Recommends:
  ${python3:Recommends}
 Suggests:

=== debian/tests/control ===
Tests: tappy.py
Depends: @, libjson-xs-perl, libtest-command-perl, perl, python3-all

Test-Command: env TEST_PROG='/usr/bin/feature-check' prove t
Depends: @, libjson-xs-perl, libtest-command-perl, perl
Features: test-name=tap-installed

Test-Command: pytest-3 python/tests/unit
Depends: @, python3-pytest
Features: test-name=upstream-pytest-python3

## feature-check 2.2.0

=== Makefile ===
--- 
+++ 
@@ -1,28 +1,7 @@
 #!/usr/bin/make -f
 #
-# Copyright (c) 2018, 2019, 2021  Peter Pentchev
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
+# SPDX-FileCopyrightText: Peter Pentchev <roam@ringlet.net>
+# SPDX-License-Identifier: BSD-2-Clause
 
 PROG=		feature-check
 
@@ -100,8 +79,8 @@
 		@echo 'Testing all the feature-check implementations complete'
 
 test-regen:
-		${FCHKDATA_PROG} -o python/unit_tests/data.py -f ${FCHKDATA_DIR}/simple.json -v python/unit_tests/data.py.hbs
-		(set -e; cd python; ${REGEN_PYTHON} -m tox -e black_reformat)
+		${FCHKDATA_PROG} -o python/tests/unit/data.py -f ${FCHKDATA_DIR}/simple.json -v python/tests/unit/data.py.hbs
+		(set -e; cd python; ${REGEN_PYTHON} -m tox -e reformat)
 		${FCHKDATA_PROG} -o t/04-simple.t -f ${FCHKDATA_DIR}/simple.json -v t/04-simple.t.hbs
 		${FCHKDATA_PROG} -o t/bin/fcheck -f ${FCHKDATA_DIR}/simple.json -v t/bin/fcheck.hbs
 		chmod 755 t/bin/fcheck

=== debian/changelog ===
feature-check (2.2.0-2) unstable; urgency=medium

  * Add the rust-thiserror-2 patch to fix FTBFS with librust-thiserror-dev 2.x.
    Closes: #1094063
  * Use debputy's X-Style: black.
  * Minor refactoring of the autopkgtest tool.

 -- Peter Pentchev <roam@debian.org>  Wed, 29 Jan 2025 21:54:54 +0200

feature-check (2.2.0-1) unstable; urgency=medium

  * Switch to X-DH-Compat for the debhelper compat level.
  * Let debhelper take care of some default dependencies.
  * Declare compliance with Policy 4.7.0 with no changes.
  * New upstream release:
    - add python3-click as a test and runtime dependency; Closes: #1071683
    - add python3-hypothesis as a dependency for one of the autopkgtests
    - refresh the line numbers in the test-invalid-options patch

 -- Peter Pentchev <roam@debian.org>  Mon, 29 Jul 2024 22:59:24 +0300

=== debian/control ===
Source: feature-check
Section: utils
Priority: optional
Maintainer: Peter Pentchev <roam@debian.org>
Build-Depends:
 debhelper (>> 13.15.2~),
 dh-sequence-python3,
 dpkg-build-api (= 1),
 cargo,
 libjson-xs-perl <!nocheck>,
 librust-anyhow-dev,
 librust-clap-derive-dev,
 librust-clap-dev,
 librust-nom-dev,
 librust-serde-derive-dev,
 librust-serde-dev,
 librust-serde-json-dev,
 librust-thiserror-dev,
 libtest-command-perl <!nocheck>,
 perl <!nocheck>,
 pybuild-plugin-pyproject,
 python3-all,
 python3-click <!nocheck>,
 python3-hatch-requirements-txt,
 python3-hatchling,
 python3-pyparsing,
 python3-pytest <!nocheck>,
Standards-Version: 4.7.0
X-DH-Compat: 14
Vcs-Git: https://salsa.debian.org/roam/feature-check.git
Vcs-Browser: https://salsa.debian.org/roam/feature-check/
Homepage: https://devel.ringlet.net/misc/feature-check/
X-Style: black

Package: feature-check
Architecture: any
Multi-Arch: foreign
Description: tool to query a program for supported features
 The feature-check tool obtains the list of supported features from
 a program via various methods (e.g. running it with the --features
 command-line option) and allows other programs to check for
 the presence and, possibly, versions of specific features.
 .
 This package contains the command-line tool for use by any program.

Package: python3-feature-check
Section: python
Architecture: all
Multi-Arch: foreign
Depends:
 python3-click,
 python3-pyparsing,
 ${python3:Depends},
Recommends:
 ${python3:Recommends},
Suggests:
 ${python3:Suggests},
Provides:
 ${python3:Provides},
Description: query a program for supported features - Python 3.x library
 The feature-check tool obtains the list of supported features from
 a program via various methods (e.g. running it with the --features
 command-line option) and allows other programs to check for
 the presence and, possibly, versions of specific features.
 .
 This package contains the Python 3.x library.

=== debian/rules ===
#!/usr/bin/make -f

D=				${CURDIR}/debian
DTMP=				$D/tmp
PY=				${CURDIR}/python

RS=				${CURDIR}/rust
RS_TGT=				${RS}/target/release
RS_BIN=				${RS_TGT}/feature-check

export PYBUILD_NAME=		feature_check
export PYBUILD_DIR=		${PY}
export PYBUILD_TEST_PYTEST=	1
export PYTEST_ADDOPTS=		${PY}/tests/unit

%:
	dh "$@"

execute_after_dh_auto_build-arch:
	mkdir -p rust/.cargo
	install -m 644 -- '$D/cargo-config.toml' '${RS}/.cargo/config.toml'
	{ \
		set -e; \
		cd -- '${RS}'; \
		cargo build --release; \
	}

execute_after_dh_auto_build-indep:
	dh_auto_build --buildsystem pybuild

override_dh_auto_install-arch:
	dh_auto_install -- \
		PREFIX=/usr \
		MANDIR=/usr/share/man/man \
		INSTALL_SCRIPT='install -m 755' \
		INSTALL_DATA='install -m 644'

	install -m 755 -- '${RS_BIN}' '${DTMP}/usr/bin/feature-check'

override_dh_auto_install-indep:
	dh_auto_install --buildsystem pybuild

execute_after_dh_auto_test-arch:
	${MAKE} test-single TEST_PROG='${RS_BIN}'

execute_after_dh_auto_test-indep:
	env PYTHONPATH='${PY}/src' debian/tests/tappy.py
	# dh_auto_test --buildsystem pybuild

override_dh_installchangelogs:
	dh_installchangelogs -X changes.md

execute_after_dh_installchangelogs-arch:
	install -m 644 -- docs/changes.md '$D/feature-check/usr/share/doc/feature-check/NEWS'

execute_after_dh_auto_clean-indep:
	dh_auto_clean --buildsystem pybuild

=== debian/tests/control ===
Tests:
 tappy.py,
Depends:
 libjson-xs-perl,
 libtest-command-perl,
 perl,
 python3-all,
 @,

Test-Command: env TEST_PROG='/usr/bin/feature-check' prove t
Depends:
 libjson-xs-perl,
 libtest-command-perl,
 perl,
 @,
Features:
 test-name=tap-installed,

Test-Command: pytest-3 python/tests/unit
Depends:
 python3-hypothesis,
 python3-pytest,
 @,
Features:
 test-name=upstream-pytest-python3,

=== debian/watch ===
version = 4

opts=pgpsigurlmangle=s/$/.asc/ \
https://devel.ringlet.net/misc/feature-check/download/ https://devel.ringlet.net/files/misc/feature-check/feature-check-@ANY_VERSION@@ARCHIVE_EXT@
